/////////////////////////////////////////////////////////////////////////////
//
//		Name:			CConfigFile
//
//		Written by:		Martin Lewis
//
//		Date:			October 1996
//
//						rewritten Feb 2011 to use wstring rather than CString.
//
/////////////////////////////////////////////////////////////////////////////
//
// CConfigFile.h : header file
//

#ifndef config_h
#define config_h

#pragma once

#include <windows.h>
#include <winioctl.h>
#include <list>
#include <string>
#include <iostream>
#include <hash_map>
#include <hash_set>
#include <tchar.h>
#include <algorithm>


using namespace std;


/////////////////////////////////////////////////////////////////////////////
// CConfigFile window

class CConfigFile 
{
// Construction
public:
	CConfigFile();
	~CConfigFile();

// Attributes
public:

	int m_iNumFileAccessRetries;

	bool LoadFile( wstring Filename );

	bool ReloadFile();

	bool GetStringValueFor	( wstring Keyword, wstring& Value );
	bool GetIntValueFor	( wstring Keyword, int& Value );
	bool GetBoolValueFor( wstring Keyword, bool& Value, bool bDefault = FALSE );

	bool GetHashStringValuesFor( wstring Keyword, stdext::hash_set<wstring>& Values );

	bool GetIntValueInRange( wstring Keyword, int& Value, int Min, int Max, int Default );

public:

	bool RawLoadFile( wstring Filename );

	wstring m_Filename;
	
	wstring TextBuffer;

	void TrimLeft( wstring& str );
	void TrimRight( wstring& str );

};

/////////////////////////////////////////////////////////////////////////////

#endif
