//---------------------------------------------------
//
// FileFilterInterfaceDefs.h
//
// Defs of types and stuctures used for communication
// between user mode and the File Filter Driver
//
//---------------------------------------------------


//	Commands that are sent to the kernel driver

typedef enum _FILEMONITOR_COMMAND 
{
    GetFileEvents,
	SetupMonitor
} 
FILEMONITOR_COMMAND;



// Structure sent to the kernal driver
// contains one of the above commands,


typedef struct _FILEMONITOR_MESSAGE 
{
    FILEMONITOR_COMMAND Command;
} FILEMONITOR_MESSAGE, *PFILEMONITOR_MESSAGE;



// Structure that is sent to the filter driver
// to define how it should initialise certain values.

typedef struct _FILEMONITOR_SETUP 
{
	BOOLEAN bCollectDeletedFiles;
	UINT nLogDirectorySize;
	WCHAR wszLogDirectory[1024];
} FILEMONITOR_SETUP, *PFILEMONITOR_SETUP;




// Structure that describes a File event 
// these are created within the filter driver
// and stored.
// The user mode code will request a buffer
// to be filled with a set of these events.
//

#pragma warning( push )
#pragma warning ( disable : 4200 )				// disable the compiler warning about
												// a zero sized array at end of the struct.

typedef struct  _FILE_EVENT 
{
	UCHAR majorFileEventType;
	UCHAR minorFileEventType;
	ULONG status;
	ULONG information;
	ULONG flags;
	LARGE_INTEGER time;
	UCHAR dataLost;		// new field
	DWORD processId;
	UINT filePathLength;
	UINT file2PathLength;	// ml : new field to allow 2 file path/names in structure.
	WCHAR filePath[];
} FILE_EVENT, *PFILE_EVENT;


#pragma warning( pop )


