#include "GenEnvData.h"
#include "Shlobj.h"
#include "Winbase.h"

GenEnvData::GenEnvData(void)
{
}


GenEnvData::~GenEnvData(void)
{
}


bool GenEnvData::GenerateEnvDataXML(  FILE* pLog, wstring filename )
{
	XMLLibWrapper XMLCreation;

	XMLCreation.CreateEnvDataDoc();

	TCHAR szPath[MAX_PATH];

	//----------------------------------------------


	if(SUCCEEDED(SHGetFolderPath(NULL,  CSIDL_DESKTOPDIRECTORY, NULL, 0, szPath))) 
	{
		XMLCreation.WriteEnvDataEntry( L"Desktop", szPath );
	}

	if(SUCCEEDED(SHGetFolderPath(NULL,  CSIDL_FONTS, NULL, 0, szPath))) 
	{
		XMLCreation.WriteEnvDataEntry( L"Fonts", szPath );
	}

	if(SUCCEEDED(SHGetFolderPath(NULL,  CSIDL_SYSTEM, NULL, 0, szPath))) 
	{
		XMLCreation.WriteEnvDataEntry( L"System", szPath );
	}

	if(SUCCEEDED(SHGetFolderPath(NULL,  CSIDL_WINDOWS, NULL, 0, szPath))) 
	{
		XMLCreation.WriteEnvDataEntry( L"Windows", szPath );
	}

	if(SUCCEEDED(SHGetFolderPath(NULL,  CSIDL_LOCAL_APPDATA, NULL, 0, szPath))) 
	{
		XMLCreation.WriteEnvDataEntry( L"LocalApplicationData", szPath );
	}

	if(SUCCEEDED(SHGetFolderPath(NULL,  CSIDL_APPDATA, NULL, 0, szPath))) 
	{
		XMLCreation.WriteEnvDataEntry( L"ApplicationData", szPath );
	}

	if(SUCCEEDED(SHGetFolderPath(NULL,  CSIDL_PROFILE, NULL, 0, szPath))) 
	{
		XMLCreation.WriteEnvDataEntry( L"Profile", szPath );
	}

	if(SUCCEEDED(SHGetFolderPath(NULL,  CSIDL_PERSONAL, NULL, 0, szPath))) 
	{
		XMLCreation.WriteEnvDataEntry( L"Personal", szPath );
	}

	if(SUCCEEDED(SHGetFolderPath(NULL,  CSIDL_STARTUP, NULL, 0, szPath))) 
	{
		XMLCreation.WriteEnvDataEntry( L"Startup", szPath );
	}

	if(SUCCEEDED(SHGetFolderPath(NULL,  CSIDL_PROGRAM_FILES, NULL, 0, szPath))) 
	{
		XMLCreation.WriteEnvDataEntry( L"ProgramFiles", szPath );
	}

	if(SUCCEEDED(SHGetFolderPath(NULL,  CSIDL_PROGRAM_FILES_COMMONX86, NULL, 0, szPath))) 
	{
		XMLCreation.WriteEnvDataEntry( L"CommonProgramFiles", szPath );
	}

	if(SUCCEEDED(SHGetFolderPath(NULL,  CSIDL_COMMON_DESKTOPDIRECTORY, NULL, 0, szPath))) 
	{
		XMLCreation.WriteEnvDataEntry( L"CommonDesktop", szPath );
	}

	if(SUCCEEDED(SHGetFolderPath(NULL,  CSIDL_COMMON_APPDATA, NULL, 0, szPath))) 
	{
		XMLCreation.WriteEnvDataEntry( L"CommonAppData", szPath );
	}

	if(SUCCEEDED(SHGetFolderPath(NULL,  CSIDL_COMMON_STARTUP, NULL, 0, szPath))) 
	{
		XMLCreation.WriteEnvDataEntry( L"CommonStartup", szPath );
	}

	
	//----------------------------------------------
	// now to get the system environment variables

    wchar_t*  lpszVariable; 
    LPVOID lpvEnv; 
 
    // Get a pointer to the environment block. 

    lpvEnv = GetEnvironmentStringsW();

    // If the returned pointer is NULL, exit.
    
	if (lpvEnv == NULL)
    {
		fwprintf( pLog,  L"Unable to get the env variables block.\n\n" );
		wprintf( L"Unable to get the env variables block.\n\n" );
        return 0;
    }
 
    // Variable strings are separated by NULL byte, and the block is 
    // terminated by a NULL byte. 

	wchar_t lpszName[500];
	
	for (lpszVariable = (wchar_t*)lpvEnv; *lpszVariable; lpszVariable++) 
    { 
		// copy the env var name into the Name variable.

		int i = 0;

		// always copy the first character
		// there is always the first char.
		// we do this to skip the '=' at the
		// start of some of the early vars

		lpszName[i++] = *lpszVariable++;

		// copy the rest of the name,
		// loop until we reach a '=' or a 0

		while ( *lpszVariable != 0 && *lpszVariable != L'=' && i < 499 ) 
		{
			lpszName[i++] = *lpszVariable++;
		}
		
		lpszName[i] = 0;								// terminate the name correctly.
		
		if (  *lpszVariable == L'=' ) lpszVariable++;	// step past the '=' to get the var value


		XMLCreation.WriteEnvDataEntry_Sysitem( lpszName, lpszVariable );


		while (*lpszVariable) lpszVariable++;	// set lpszVariable to null char at end of string.
    }

    FreeEnvironmentStringsW( (wchar_t*)lpvEnv );

	//----------------------------------------------

	XMLCreation.SaveEnvDataDoc( filename.c_str() );

	return false;
}