//----------------------------------------------------------------------------
//
//	ThreadControl Class
//
//  Allows Threads to be initiated in an OO manner in C++
//
//
//  Code influenced by examples at
//
//		http://www.codeproject.com/KB/threads/ThreadClass.aspx
//
//
//
//
//----------------------------------------------------------------------------


#pragma once
#include <windows.h>


struct Runnable 
{
  virtual void run() = 0;
};





class OOThreadHandler
{
public:

	OOThreadHandler(Runnable *ptr) 
	{
		_threadObj = ptr;
	}


	DWORD start() 
	{
		DWORD threadID;

		hThread = CreateThread(0, 0, threadProc, _threadObj, 0, &threadID);
		
		return threadID;
	}

  
protected:

	HANDLE hThread;

	Runnable *_threadObj;

	static unsigned long __stdcall threadProc(void* ptr) 
	{
		((Runnable*)ptr)->run();
		return 0;
	}

};

